#!/bin/bash
# Author: Steven Shiau <steven _at_ nchc org tw>
# License: GPL
# Description: This script will create a Debian live cd iso which is used as a template for clonezilla image with restoration function.

if [ ! -f "/opt/drbl/sbin/drbl-conf-functions" ]; then
  echo "Unable to find /opt/drbl/sbin/drbl-conf-functions! Program terminated!" 
  exit 1
fi
. /opt/drbl/sbin/drbl-conf-functions

mirror_url="http://free.nchc.org.tw/debian"
mirror_security_url="http://free.nchc.org.tw/debian-security/"
# debian_type can be minimal (about 67 MB for Etch)/minimal-net (about 85 MB for Etch).
# We have to use standard, since if using minimal, it will ignore apt key from DRBL.
#debian_type="minimal"
debian_type="standard"
debian_dist="etch"
pkgs="drbl $PKG_FROM_DBN_WHICH_OCS_LIVE_NEED $PKG_FROM_DBN"
target_iso="clonezilla-server-live-`date +%Y%m%d`.iso"
ocs_live_script="$DRBL_SCRIPT_PATH/setup/files/ocs/live-chroot"
# The files in dir $ocs_live_script/ will be copied to the root (/) dir in dir chroot when make-live is run with --include-chroot. The file "ocs-srv-live-hook" is in $ocs_live_script
# The script will be run when chroot
hook_script="/drbl_hook"

# DRBL repository
LIVE_REPOSITORIES="drbl"
LIVE_REPOSITORY_drbl="http://free.nchc.org.tw/drbl-core"
# url to the repository key
LIVE_REPOSITORY_KEY_drbl="http://drbl.nchc.org.tw/GPG-KEY-DRBL"
# the name of the keyring
LIVE_REPOSITORY_KEYRING_drbl=""
# the name of your distribution
LIVE_REPOSITORY_DISTRIBUTION_drbl="drbl"
# sections
LIVE_REPOSITORY_SECTIONS_drbl="stable testing unstable"
export LIVE_REPOSITORIES LIVE_REPOSITORY_drbl LIVE_REPOSITORY_KEY_drbl LIVE_REPOSITORY_KEYRING_drbl LIVE_REPOSITORY_DISTRIBUTION_drbl LIVE_REPOSITORY_SECTIONS_drbl

#
check_if_root
#
prog="$(basename $0)"

# functions
USAGE() {
    echo "Usage:"
    echo "To create a Debian live CD which is used a template for Clonezilla live:"
    echo "$prog [OPTION]"
    echo "OPTION:"
    echo "-v, --verbose   Run make-live in verbose mode"
}

# Parse command-line options
while [ $# -gt 0 ]; do
  case "$1" in
    -v|--verbose)
	    verbose="on"
            shift ;;
    -*)     echo "${0}: ${1}: invalid option" >&2
            USAGE >& 2
            exit 2 ;;
    *)      break ;;
  esac
done

if ! type make-live &>/dev/null; then
  [ "$BOOTUP" = "color" ] && $SETCOLOR_FAILURE
  echo "This script only works in Debian Etch or later!"
  echo "If you are running Debian Etch or later, use 'apt-get install live-package' to install the necessary packages, then run $0 again."
  [ "$BOOTUP" = "color" ] && $SETCOLOR_NORMAL
  exit 1
fi

[ "$BOOTUP" = "color" ] && $SETCOLOR_WARNING
echo "Creating a Debian live cd iso which is used for clonezilla image with restoration function. The created iso will be in $target_iso" 
[ "$BOOTUP" = "color" ] && $SETCOLOR_NORMAL

rm -rf debian-live/.stage/

if [ "$verbose" = "on" ]; then
  pref="bash -x"
fi

# add the script in /usr/share/make-live/hooks/minimal
if ! grep -q "/ocs-srv-live-hook" /usr/share/make-live/hooks/$debian_type; then
 echo "/ocs-srv-live-hook" >> /usr/share/make-live/hooks/$debian_type
fi
$pref make-live --mirror $mirror_url --mirror-security $mirror_security_url --distribution $debian_dist --flavour $debian_type --without-generic-indices --packages "$pkgs" --include-chroot "$ocs_live_script" --bootappend ip=frommedia
# remove the line /ocs-srv-live-hook in /usr/share/make-live/hooks/minimal
perl -i -ne "print unless /^\/ocs-srv-live-hook/ .. /.*$/" /usr/share/make-live/hooks/$debian_type
mv -f debian-live/binary.iso $target_iso
